## AgsChorusUtil

AgsChorusUtil — chorus util

## Stability Level

Stable, unless otherwise indicated

## Functions

AgsChorusUtil * | ags_chorus_util_alloc ()
gpointer | ags_chorus_util_copy ()
void | ags_chorus_util_free ()
gpointer | ags_chorus_util_get_source ()
void | ags_chorus_util_set_source ()
guint | ags_chorus_util_get_source_stride ()
void | ags_chorus_util_set_source_stride ()
gpointer | ags_chorus_util_get_destination ()
void | ags_chorus_util_set_destination ()
guint | ags_chorus_util_get_destination_stride ()
void | ags_chorus_util_set_destination_stride ()
guint | ags_chorus_util_get_buffer_length ()
void | ags_chorus_util_set_buffer_length ()
guint | ags_chorus_util_get_format ()
void | ags_chorus_util_set_format ()
guint | ags_chorus_util_get_samplerate ()
void | ags_chorus_util_set_samplerate ()
guint64 | ags_chorus_util_get_offset ()
void | ags_chorus_util_set_offset ()
gdouble | ags_chorus_util_get_base_key ()
void | ags_chorus_util_set_base_key ()
gdouble | ags_chorus_util_get_input_volume ()
void | ags_chorus_util_set_input_volume ()
gdouble | ags_chorus_util_get_output_volume ()
void | ags_chorus_util_set_output_volume ()
guint | ags_chorus_util_get_lfo_oscillator ()
void | ags_chorus_util_set_lfo_oscillator ()
gdouble | ags_chorus_util_get_lfo_frequency ()
void | ags_chorus_util_set_lfo_frequency ()
gdouble | ags_chorus_util_get_depth ()
void | ags_chorus_util_set_depth ()
gdouble | ags_chorus_util_get_mix ()
void | ags_chorus_util_set_mix ()
gdouble | ags_chorus_util_get_delay ()
void | ags_chorus_util_set_delay ()
GType | ags_chorus_util_get_pitch_type ()
void | ags_chorus_util_set_pitch_type ()
gpointer | ags_chorus_util_get_pitch_util ()
void | ags_chorus_util_set_pitch_util ()
gboolean | ags_chorus_util_get_note_256th_mode ()
void | ags_chorus_util_set_note_256th_mode ()
guint | ags_chorus_util_get_offset_256th ()
void | ags_chorus_util_set_offset_256th ()
void | ags_chorus_util_compute_s8 ()
void | ags_chorus_util_compute_s16 ()
void | ags_chorus_util_compute_s24 ()
void | ags_chorus_util_compute_s32 ()
void | ags_chorus_util_compute_s64 ()
void | ags_chorus_util_compute_float ()
void | ags_chorus_util_compute_double ()
void | ags_chorus_util_compute_complex ()
void | ags_chorus_util_compute ()

## Types and Values

#define | AGS_CHORUS_UTIL_DEFAULT_PITCH_MIX_BUFFER_SIZE
#define | AGS_CHORUS_UTIL_DEFAULT_HISTORY_BUFFER_LENGTH
#define | AGS_CHORUS_UTIL_DEFAULT_LFO_OSCILLATOR
#define | AGS_CHORUS_UTIL_DEFAULT_LFO_FREQUENCY
#define | AGS_CHORUS_UTIL_DEFAULT_DEPTH
#define | AGS_CHORUS_UTIL_DEFAULT_MIX
#define | AGS_CHORUS_UTIL_DEFAULT_DELAY
#define | AGS_CHORUS_UTIL_INITIALIZER

## Object Hierarchy

        GBoxed
        ╰── AgsChorusUtil

## Includes

    #include <ags/audio/ags_chorus_util.h>

## Description

Utility functions to chorus.

## Functions

### ags_chorus_util_alloc ()

    AgsChorusUtil *
    ags_chorus_util_alloc ();

Allocate AgsChorusUtil.

#### Returns

the newly allocated AgsChorusUtil

Since: 3.13.4

### ags_chorus_util_copy ()

    gpointer
    ags_chorus_util_copy (AgsChorusUtil *ptr);

Create a copy of `ptr` .

#### Parameters

ptr | the original AgsChorusUtil |

#### Returns

a pointer of the new AgsChorusUtil

Since: 3.13.4

### ags_chorus_util_free ()

    void
    ags_chorus_util_free (AgsChorusUtil *ptr);

Free the memory of `ptr` .

#### Parameters

ptr | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_get_source ()

    gpointer
    ags_chorus_util_get_source (AgsChorusUtil *chorus_util);

Get source buffer of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the source buffer

Since: 3.13.4

### ags_chorus_util_set_source ()

    void
    ags_chorus_util_set_source (AgsChorusUtil *chorus_util,
                                gpointer source);

Set `source` buffer of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
source | the source buffer. | [transfer none]

Since: 3.13.4

### ags_chorus_util_get_source_stride ()

    guint
    ags_chorus_util_get_source_stride (AgsChorusUtil *chorus_util);

Get source stride of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the source buffer stride

Since: 3.13.4

### ags_chorus_util_set_source_stride ()

    void
    ags_chorus_util_set_source_stride (AgsChorusUtil *chorus_util,
                                       guint source_stride);

Set `source` stride of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
source_stride | the source buffer stride |

Since: 3.13.4

### ags_chorus_util_get_destination ()

    gpointer
    ags_chorus_util_get_destination (AgsChorusUtil *chorus_util);

Get destination buffer of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the destination buffer

Since: 3.13.4

### ags_chorus_util_set_destination ()

    void
    ags_chorus_util_set_destination (AgsChorusUtil *chorus_util,
                                     gpointer destination);

Set `destination` buffer of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
destination | the destination buffer. | [transfer none]

Since: 3.13.4

### ags_chorus_util_get_destination_stride ()

    guint
    ags_chorus_util_get_destination_stride
                                   (AgsChorusUtil *chorus_util);

Get destination stride of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the destination buffer stride

Since: 3.13.4

### ags_chorus_util_set_destination_stride ()

    void
    ags_chorus_util_set_destination_stride
                                   (AgsChorusUtil *chorus_util,
                                    guint destination_stride);

Set `destination` stride of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
destination_stride | the destination buffer stride |

Since: 3.13.4

### ags_chorus_util_get_buffer_length ()

    guint
    ags_chorus_util_get_buffer_length (AgsChorusUtil *chorus_util);

Get buffer length of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the buffer length

Since: 3.13.4

### ags_chorus_util_set_buffer_length ()

    void
    ags_chorus_util_set_buffer_length (AgsChorusUtil *chorus_util,
                                       guint buffer_length);

Set `buffer_length` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
buffer_length | the buffer length |

Since: 3.13.4

### ags_chorus_util_get_format ()

    guint
    ags_chorus_util_get_format (AgsChorusUtil *chorus_util);

Get format of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the format

Since: 3.13.4

### ags_chorus_util_set_format ()

    void
    ags_chorus_util_set_format (AgsChorusUtil *chorus_util,
                                guint format);

Set `format` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
format | the format |

Since: 3.13.4

### ags_chorus_util_get_samplerate ()

    guint
    ags_chorus_util_get_samplerate (AgsChorusUtil *chorus_util);

Get samplerate of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the samplerate

Since: 3.13.4

### ags_chorus_util_set_samplerate ()

    void
    ags_chorus_util_set_samplerate (AgsChorusUtil *chorus_util,
                                    guint samplerate);

Set `samplerate` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
samplerate | the samplerate |

Since: 3.13.4

### ags_chorus_util_get_offset ()

    guint64
    ags_chorus_util_get_offset (AgsChorusUtil *chorus_util);

Get offset of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the offset

Since: 4.0.0

### ags_chorus_util_set_offset ()

    void
    ags_chorus_util_set_offset (AgsChorusUtil *chorus_util,
                                guint64 offset);

Set `offset` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
offset | the offset |

Since: 4.0.0

### ags_chorus_util_get_base_key ()

    gdouble
    ags_chorus_util_get_base_key (AgsChorusUtil *chorus_util);

Get base key of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the base key

Since: 3.13.4

### ags_chorus_util_set_base_key ()

    void
    ags_chorus_util_set_base_key (AgsChorusUtil *chorus_util,
                                  gdouble base_key);

Set `base_key` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
base_key | the base key |

Since: 3.13.4

### ags_chorus_util_get_input_volume ()

    gdouble
    ags_chorus_util_get_input_volume (AgsChorusUtil *chorus_util);

Get input volume of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the input volume

Since: 3.13.4

### ags_chorus_util_set_input_volume ()

    void
    ags_chorus_util_set_input_volume (AgsChorusUtil *chorus_util,
                                      gdouble input_volume);

Set `input_volume` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
input_volume | the input volume |

Since: 3.13.4

### ags_chorus_util_get_output_volume ()

    gdouble
    ags_chorus_util_get_output_volume (AgsChorusUtil *chorus_util);

Get output volume of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the output volume

Since: 3.13.4

### ags_chorus_util_set_output_volume ()

    void
    ags_chorus_util_set_output_volume (AgsChorusUtil *chorus_util,
                                       gdouble output_volume);

Set `output_volume` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
output_volume | the output volume |

Since: 3.13.4

### ags_chorus_util_get_lfo_oscillator ()

    guint
    ags_chorus_util_get_lfo_oscillator (AgsChorusUtil *chorus_util);

Get LFO oscillator of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the LFO oscillator of AgsSynthOscillatorMode

Since: 3.13.4

### ags_chorus_util_set_lfo_oscillator ()

    void
    ags_chorus_util_set_lfo_oscillator (AgsChorusUtil *chorus_util,
                                        guint lfo_oscillator);

Set `lfo_oscillator` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
lfo_oscillator | the LFO oscillator of AgsSynthOscillatorMode |

Since: 3.13.4

### ags_chorus_util_get_lfo_frequency ()

    gdouble
    ags_chorus_util_get_lfo_frequency (AgsChorusUtil *chorus_util);

Get LFO frequency of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the LFO frequency

Since: 3.13.4

### ags_chorus_util_set_lfo_frequency ()

    void
    ags_chorus_util_set_lfo_frequency (AgsChorusUtil *chorus_util,
                                       gdouble lfo_frequency);

Set `lfo_frequency` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
lfo_frequency | the LFO frequency |

Since: 3.13.4

### ags_chorus_util_get_depth ()

    gdouble
    ags_chorus_util_get_depth (AgsChorusUtil *chorus_util);

Get depth of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the depth

Since: 3.13.4

### ags_chorus_util_set_depth ()

    void
    ags_chorus_util_set_depth (AgsChorusUtil *chorus_util,
                               gdouble depth);

Set `depth` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
depth | the depth |

Since: 3.13.4

### ags_chorus_util_get_mix ()

    gdouble
    ags_chorus_util_get_mix (AgsChorusUtil *chorus_util);

Get mix of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the mix

Since: 3.13.4

### ags_chorus_util_set_mix ()

    void
    ags_chorus_util_set_mix (AgsChorusUtil *chorus_util,
                             gdouble mix);

Set `mix` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
mix | the mix |

Since: 3.13.4

### ags_chorus_util_get_delay ()

    gdouble
    ags_chorus_util_get_delay (AgsChorusUtil *chorus_util);

Get delay of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the delay

Since: 3.13.4

### ags_chorus_util_set_delay ()

    void
    ags_chorus_util_set_delay (AgsChorusUtil *chorus_util,
                               gdouble delay);

Set `delay` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
delay | the delay |

Since: 3.13.4

### ags_chorus_util_get_pitch_type ()

    GType
    ags_chorus_util_get_pitch_type (AgsChorusUtil *chorus_util);

Get pitch type of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the pitch type

Since: 4.0.0

### ags_chorus_util_set_pitch_type ()

    void
    ags_chorus_util_set_pitch_type (AgsChorusUtil *chorus_util,
                                    GType pitch_type);

Set `pitch_type` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
pitch_type | the pitch type |

Since: 4.0.0

### ags_chorus_util_get_pitch_util ()

    gpointer
    ags_chorus_util_get_pitch_util (AgsChorusUtil *chorus_util);

Get pitch util of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the pitch util.

[transfer none]

Since: 4.0.0

### ags_chorus_util_set_pitch_util ()

    void
    ags_chorus_util_set_pitch_util (AgsChorusUtil *chorus_util,
                                    gpointer pitch_util);

Set `pitch_util` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
pitch_util | the pitch util. | [transfer full]

Since: 4.0.0

### ags_chorus_util_get_note_256th_mode ()

    gboolean
    ags_chorus_util_get_note_256th_mode (AgsChorusUtil *chorus_util);

Get note 256th mode of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

`TRUE` if note 256th mode, otherwise `FALSE`

Since: 6.1.0

### ags_chorus_util_set_note_256th_mode ()

    void
    ags_chorus_util_set_note_256th_mode (AgsChorusUtil *chorus_util,
                                         gboolean note_256th_mode);

Set `note_256th_mode` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
note_256th_mode | the note 256th mode |

Since: 6.1.0

### ags_chorus_util_get_offset_256th ()

    guint
    ags_chorus_util_get_offset_256th (AgsChorusUtil *chorus_util);

Get offset as note 256th of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

#### Returns

the offset as note 256th

Since: 6.1.0

### ags_chorus_util_set_offset_256th ()

    void
    ags_chorus_util_set_offset_256th (AgsChorusUtil *chorus_util,
                                      guint offset_256th);

Set `offset_256th` of `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |
offset_256th | the offset as note 256th |

Since: 6.1.0

### ags_chorus_util_compute_s8 ()

    void
    ags_chorus_util_compute_s8 (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of signed 8 bit data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_s16 ()

    void
    ags_chorus_util_compute_s16 (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of signed 16 bit data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_s24 ()

    void
    ags_chorus_util_compute_s24 (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of signed 24 bit data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_s32 ()

    void
    ags_chorus_util_compute_s32 (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of signed 32 bit data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_s64 ()

    void
    ags_chorus_util_compute_s64 (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of signed 64 bit data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_float ()

    void
    ags_chorus_util_compute_float (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of floating point data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_double ()

    void
    ags_chorus_util_compute_double (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of double precision floating point data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute_complex ()

    void
    ags_chorus_util_compute_complex (AgsChorusUtil *chorus_util);

Choralize `chorus_util` of complex data.

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

### ags_chorus_util_compute ()

    void
    ags_chorus_util_compute (AgsChorusUtil *chorus_util);

Choralize `chorus_util` .

#### Parameters

chorus_util | the AgsChorusUtil |

Since: 3.13.4

## Types and Values

### AGS_CHORUS_UTIL_DEFAULT_PITCH_MIX_BUFFER_SIZE

    #define AGS_CHORUS_UTIL_DEFAULT_PITCH_MIX_BUFFER_SIZE (65536)

### AGS_CHORUS_UTIL_DEFAULT_HISTORY_BUFFER_LENGTH

    #define AGS_CHORUS_UTIL_DEFAULT_HISTORY_BUFFER_LENGTH (256)

### AGS_CHORUS_UTIL_DEFAULT_LFO_OSCILLATOR

    #define AGS_CHORUS_UTIL_DEFAULT_LFO_OSCILLATOR (AGS_SYNTH_OSCILLATOR_SIN)

### AGS_CHORUS_UTIL_DEFAULT_LFO_FREQUENCY

    #define AGS_CHORUS_UTIL_DEFAULT_LFO_FREQUENCY (10.0)

### AGS_CHORUS_UTIL_DEFAULT_DEPTH

    #define AGS_CHORUS_UTIL_DEFAULT_DEPTH (0.0)

### AGS_CHORUS_UTIL_DEFAULT_MIX

    #define AGS_CHORUS_UTIL_DEFAULT_MIX (1.0)

### AGS_CHORUS_UTIL_DEFAULT_DELAY

    #define AGS_CHORUS_UTIL_DEFAULT_DELAY (0.0)

### AGS_CHORUS_UTIL_INITIALIZER

    #define             AGS_CHORUS_UTIL_INITIALIZER